autofs-5.1.9 - add en extra logging entry to tree_mapent_mount_offsets()

From: Ian Kent <raven@themaw.net>

Add an often useful bit of debug information.

Signed-off-by: Ian Kent <raven@themaw.net>
---
 CHANGELOG    |    1 +
 lib/mounts.c |    2 ++
 2 files changed, 3 insertions(+)

diff --git a/CHANGELOG b/CHANGELOG
index 92210eb72..9afc7018f 100644
--- a/CHANGELOG
+++ b/CHANGELOG
@@ -68,6 +68,7 @@
 - fix timed_read() error return.
 - fix state queue not processing state changes.
 - refactor mnts_get_expire_list().
+- add en extra logging entry to tree_mapent_mount_offsets().
 
 02/11/2023 autofs-5.1.9
 - fix kernel mount status notification.
diff --git a/lib/mounts.c b/lib/mounts.c
index c2b8ed7cc..7aae5bb01 100644
--- a/lib/mounts.c
+++ b/lib/mounts.c
@@ -2032,6 +2032,8 @@ int tree_mapent_mount_offsets(struct mapent *oe, int nonstrict)
 		.strict = !nonstrict,
 	};
 
+	debug(ctxt.ap->logopt, "mounting offsets at base %s", oe->key);
+
 	return tree_mapent_traverse_subtree(base,
 				tree_mapent_mount_offsets_work, &ctxt);
 }