autofs-5.1.9 - fix error return in do_mount_indirect()

From: Ian Kent <raven@themaw.net>

Setting of an error return status is missing from a test case in
daemon/indirect.c:do_mount_indirect().

Signed-off-by: Ian Kent <raven@themaw.net>
---
 CHANGELOG         |    1 +
 daemon/indirect.c |    1 +
 2 files changed, 2 insertions(+)

diff --git a/CHANGELOG b/CHANGELOG
index af0736d71..e361c4df4 100644
--- a/CHANGELOG
+++ b/CHANGELOG
@@ -54,6 +54,7 @@
 - use nobind instead of nosymlink.
 - make rmdir_path() more informative.
 - remove unused master map field.
+- fix error return in do_mount_indirect().
 
 02/11/2023 autofs-5.1.9
 - fix kernel mount status notification.
diff --git a/daemon/indirect.c b/daemon/indirect.c
index 7d4aad79d..481f802e0 100644
--- a/daemon/indirect.c
+++ b/daemon/indirect.c
@@ -734,6 +734,7 @@ static void *do_mount_indirect(void *arg)
 	if (status != -1 && !(S_ISDIR(st.st_mode) && st.st_dev == mt.dev)) {
 		error(ap->logopt,
 		      "indirect trigger not valid or already mounted %s", buf);
+		mt.status = -EINVAL;
 		pthread_setcancelstate(state, NULL);
 		pthread_exit(NULL);
 	}