autofs-5.1.9 - fix type mismatch in mount_autofs_direct()

From: Ian Kent <raven@themaw.net>

Fix mismatching size of an assignment in function mount_autofs_direct().

Signed-off-by: Ian Kent <raven@themaw.net>
---
 CHANGELOG       |    1 +
 daemon/direct.c |    2 +-
 2 files changed, 2 insertions(+), 1 deletion(-)

diff --git a/CHANGELOG b/CHANGELOG
index 57beddfc9..4bbb7d177 100644
--- a/CHANGELOG
+++ b/CHANGELOG
@@ -48,6 +48,7 @@
 - fix off by one error in macro_init().
 - fix incorrect allocation in match_key().
 - dont use alloca for nfsoptions.
+- fix type mismatch in mount_autofs_direct().
 
 02/11/2023 autofs-5.1.9
 - fix kernel mount status notification.
diff --git a/daemon/direct.c b/daemon/direct.c
index 596201e94..34cf2cf2d 100644
--- a/daemon/direct.c
+++ b/daemon/direct.c
@@ -486,7 +486,7 @@ int mount_autofs_direct(struct autofs_point *ap)
 			cache_writelock(nc);
 			ne = cache_lookup_distinct(nc, me->key);
 			if (ne) {
-				unsigned int ne_age = ne->age;
+				time_t ne_age = ne->age;
 
 				cache_unlock(nc);
 				if (map->master_line < ne_age) {