autofs-5.1.9 - use nobind instead of nosymlink

From: Ian Kent <raven@themaw.net>

The nosymlink option is depricated in favour of using the nobind option
so use the nobind variable for this also.

Signed-off-by: Ian Kent <raven@themaw.net>
---
 CHANGELOG           |    1 +
 modules/mount_nfs.c |    9 +++------
 2 files changed, 4 insertions(+), 6 deletions(-)

diff --git a/CHANGELOG b/CHANGELOG
index f76a9bb31..f1162eee8 100644
--- a/CHANGELOG
+++ b/CHANGELOG
@@ -51,6 +51,7 @@
 - fix type mismatch in mount_autofs_direct().
 - fix multiply defined proximity.
 - fix incorrect call in dev_ioctl_requester().
+- use nobind instead of nosymlink.
 
 02/11/2023 autofs-5.1.9
 - fix kernel mount status notification.
diff --git a/modules/mount_nfs.c b/modules/mount_nfs.c
index 57fb04d68..0d13b3679 100644
--- a/modules/mount_nfs.c
+++ b/modules/mount_nfs.c
@@ -73,7 +73,6 @@ int mount_mount(struct autofs_point *ap, const char *root, const char *name, int
 	int symlink = (*name != '/' && (ap->flags & MOUNT_FLAG_SYMLINK));
 	int nobind = ap->flags & MOUNT_FLAG_NOBIND;
 	int len, status, err, existed = 1;
-	int nosymlink = 0;
 	int port = -1;
 	int ro = 0;            /* Set if mount bind should be read-only */
 	int rdma = 0;
@@ -144,7 +143,7 @@ int mount_mount(struct autofs_point *ap, const char *root, const char *name, int
 				     "the \"nosymlink\" option is depricated "
 				     "and will soon be removed, "
 				     "use the \"nobind\" option instead");
-				nosymlink = 1;
+				nobind = 1;
 			} else if (_strncmp("symlink", cp, o_len) == 0) {
 				if (*name != '/')
 					symlink = 1;
@@ -211,8 +210,7 @@ int mount_mount(struct autofs_point *ap, const char *root, const char *name, int
 			vers |= NFS_PROTO_MASK;
 
 		mountlog(ap->logopt, MODPREFIX
-			 "nfs options=\"%s\", nobind=%d, nosymlink=%d, ro=%d",
-			 nfsoptions, nobind, nosymlink, ro);
+			 "nfs options=\"%s\", nobind=%d, ro=%d", nfsoptions, nobind, ro);
 	}
 
 	/* Construct mount point directory */
@@ -302,8 +300,7 @@ dont_probe:
 		char *loc;
 
 		/* Port option specified, don't try to bind */
-		if (!(nosymlink || nobind) &&
-		    this->proximity == PROXIMITY_LOCAL) {
+		if (!nobind && this->proximity == PROXIMITY_LOCAL) {
 			/* Local host -- do a "bind" */
 			const char *bind_options;
 