autofs-5.1.9 - use sizeof for buffer length in set_log_priority

From: Ian Kent <raven@themaw.net>

Keep this io length check independent of defined size names so we can
change the macro name or value easlily if needed.

Signed-off-by: Ian Kent <raven@themaw.net>
---
 CHANGELOG          |    1 +
 daemon/automount.c |    2 +-
 2 files changed, 2 insertions(+), 1 deletion(-)

diff --git a/CHANGELOG b/CHANGELOG
index e361c4df4..9fac507f2 100644
--- a/CHANGELOG
+++ b/CHANGELOG
@@ -55,6 +55,7 @@
 - make rmdir_path() more informative.
 - remove unused master map field.
 - fix error return in do_mount_indirect().
+- use sizeof for buffer length in set_log_priority.
 
 02/11/2023 autofs-5.1.9
 - fix kernel mount status notification.
diff --git a/daemon/automount.c b/daemon/automount.c
index e7c905063..e89148182 100644
--- a/daemon/automount.c
+++ b/daemon/automount.c
@@ -1571,7 +1571,7 @@ static int set_log_priority(const char *path, int priority)
 	 * representation of the integer log priority.
 	 */
 	ret = snprintf(buf, sizeof(buf), "%ld %d", devid, priority);
-	if (ret >= FIFO_BUF_SIZE) {
+	if (ret >= sizeof(buf)) {
 		fprintf(stderr, "Invalid device id or log priotity\n");
 		return -1;
 	}